diff -Naur --exclude=CVS --exclude=configs linux/mm/oom_kill.c linux-openmosix/mm/oom_kill.c
--- linux/mm/oom_kill.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/mm/oom_kill.c	2004-02-05 10:51:31.000000000 +0100
@@ -25,6 +25,7 @@
 
 /* #define DEBUG */
 
+
 /**
  * int_sqrt - oom_kill.c internal function, rough approximation to sqrt
  * @x: integer of which to calculate the sqrt
@@ -95,6 +96,11 @@
 	 * Superuser processes are usually more important, so we make it
 	 * less likely that we kill those.
 	 */
+#ifdef CONFIG_MOSIX
+	if(p->mosix.dflags & DREMOTE)
+		points *= 2;
+	else
+#endif /* CONFIG_MOSIX */
 	if (cap_t(p->cap_effective) & CAP_TO_MASK(CAP_SYS_ADMIN) ||
 				p->uid == 0 || p->euid == 0)
 		points /= 4;
@@ -105,6 +111,9 @@
 	 * tend to only have this flag set on applications they think
 	 * of as important.
 	 */
+#ifdef CONFIG_MOSIX
+	if(!(p->mosix.dflags & DREMOTE))
+#endif /* CONFIG_MOSIX */
 	if (cap_t(p->cap_effective) & CAP_TO_MASK(CAP_SYS_RAWIO))
 		points /= 4;
 #ifdef DEBUG
@@ -155,6 +164,11 @@
 	p->counter = 5 * HZ;
 
 	/* This process has hardware access, be more careful. */
+#ifdef CONFIG_MOSIX
+	if(p->mosix.dflags & DREMOTE)
+		send_sig(SIGTERM, p, 1);
+	else
+#endif /* CONFIG_MOSIX */
 	if (cap_t(p->cap_effective) & CAP_TO_MASK(CAP_SYS_RAWIO)) {
 		force_sig(SIGTERM, p);
 	} else {
@@ -174,6 +188,17 @@
 {
 	struct task_struct *p, *q;
 
+#ifdef CONFIG_MOSIX_NO_OOM
+
+/* We don't need no stinking OOM in openMosix
+ * Rather, we just send a message to syslog that the system
+ * is out of memory and let fate take over the system  - Moshe Bar  */
+
+	printk("openMosix: this node is seriously out of memory due to VM overcommit. I think I will pass out now.\n");
+  
+	return;
+#endif 
+
 	read_lock(&tasklist_lock);
 	p = select_bad_process();
 
diff -Naur --exclude=CVS --exclude=configs linux/mm/page_alloc.c linux-openmosix/mm/page_alloc.c
--- linux/mm/page_alloc.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/mm/page_alloc.c	2004-02-05 10:51:31.000000000 +0100
@@ -397,7 +397,20 @@
 		goto out;
 
  rebalance:
+#ifdef CONFIG_MOSIX
+	{
+		__typeof__(jiffies)before = jiffies;
+#endif /* CONFIG_MOSIX */
 	page = balance_classzone(classzone, gfp_mask, order, &freed);
+#ifdef CONFIG_MOSIX
+	if((before = jiffies - before))
+#if 1000000 % HZ == 0
+		current->mosix.pagetime += before * (1000000 / HZ);
+#else
+		current->mosix.pagetime += before * 1000000 / HZ;
+#endif
+}
+#endif /* CONFIG_MOSIX */
 	if (page)
 		return page;
 
diff -Naur --exclude=CVS --exclude=configs linux/mm/vmscan.c linux-openmosix/mm/vmscan.c
--- linux/mm/vmscan.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/mm/vmscan.c	2004-02-05 10:51:31.000000000 +0100
@@ -79,6 +79,15 @@
 	pte_t pte;
 	swp_entry_t entry;
 
+#ifdef CONFIG_MOSIX
+	/* no swap_out conflict here - Copyright by Qlusters, Inc. */
+	if(page->young)
+	{
+		page->young = 0;
+		return(0);
+	}
+#endif /* CONFIG_MOSIX */
+
 	/* Don't look at this pte if it's been accessed recently. */
 	if ((vma->vm_flags & VM_LOCKED) || ptep_test_and_clear_young(page_table)) {
 		mark_page_accessed(page);
@@ -817,6 +826,10 @@
 		 * the processes needing more memory will wake us
 		 * up on a more timely basis.
 		 */
+#ifdef CONFIG_MOSIX
+		refill_inactive(-(nr_active_pages + 63) >> 6,
+					NODE_DATA(0)->node_zones);
+#endif /* CONFIG_MOSIX */
 		kswapd_balance();
 		run_task_queue(&tq_disk);
 	}
diff -Naur --exclude=CVS --exclude=configs linux/net/802/cl2llc.c linux-openmosix/net/802/cl2llc.c
--- linux/net/802/cl2llc.c	2001-04-06 19:51:19.000000000 +0200
+++ linux-openmosix/net/802/cl2llc.c	2004-02-05 10:51:32.000000000 +0100
@@ -96,7 +96,7 @@
 				else
 					llc_interpret_pseudo_code(lp, REJECT1, skb, NO_FRAME);
 				break;
-			default:;
+			default:
 		}
 		if(lp->llc_callbacks)
 		{
@@ -497,7 +497,7 @@
 				else
 					lp->f_flag = fr->i_hdr.i_pflag;
 				break;
-			default:;
+			default:
 		}
 		pc++;	
 	}
diff -Naur --exclude=CVS --exclude=configs linux/net/core/scm.c linux-openmosix/net/core/scm.c
--- linux/net/core/scm.c	2001-12-21 18:42:05.000000000 +0100
+++ linux-openmosix/net/core/scm.c	2004-02-05 10:51:32.000000000 +0100
@@ -31,6 +31,9 @@
 #include <net/sock.h>
 #include <net/scm.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
 
 /*
  *	Only allow a user to send credentials, that they could set with 
@@ -81,6 +84,12 @@
 	 *	Verify the descriptors and increment the usage count.
 	 */
 	 
+#ifdef CONFIG_MOSIX_DFSA
+	/* this is massive and rare, so rather than make special cases: */
+	if(current->mosix.dflags & DREMOTE)
+		return(-EDOITATHOME);
+	dfsa_is_not_up_to_date();
+#endif /* CONFIG_MOSIX_DFSA */
 	for (i=0; i< num; i++)
 	{
 		int fd = fdp[i];
@@ -206,6 +215,10 @@
 	int *cmfptr;
 	int err = 0, i;
 
+#ifdef CONFIG_MOSIX_DFSA
+	if(current->mosix.dflags & DREMOTE)
+		panic("scm_detach_fds: REMOTE");
+#endif /* CONFIG_MOSIX_DFSA */
 	if (msg->msg_controllen > sizeof(struct cmsghdr))
 		fdmax = ((msg->msg_controllen - sizeof(struct cmsghdr))
 			 / sizeof(int));
diff -Naur --exclude=CVS --exclude=configs linux/net/core/skbuff.c linux-openmosix/net/core/skbuff.c
--- linux/net/core/skbuff.c	2003-08-25 13:44:44.000000000 +0200
+++ linux-openmosix/net/core/skbuff.c	2004-02-05 10:51:32.000000000 +0100
@@ -61,6 +61,10 @@
 #include <asm/uaccess.h>
 #include <asm/system.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 int sysctl_hot_list_len = 128;
 
 static kmem_cache_t *skbuff_head_cache;
diff -Naur --exclude=CVS --exclude=configs linux/net/core/sock.c linux-openmosix/net/core/sock.c
--- linux/net/core/sock.c	2003-06-13 16:51:39.000000000 +0200
+++ linux-openmosix/net/core/sock.c	2004-02-05 10:51:32.000000000 +0100
@@ -128,6 +128,10 @@
 #include <net/tcp.h>
 #endif
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /* Run time adjustable parameters. */
 __u32 sysctl_wmem_max = SK_WMEM_MAX;
 __u32 sysctl_rmem_max = SK_RMEM_MAX;
@@ -1138,6 +1142,10 @@
 	if (sk->sleep && waitqueue_active(sk->sleep))
 		wake_up_interruptible(sk->sleep);
 	sk_wake_async(sk,1,POLL_IN);
+#ifdef CONFIG_MOSIX
+	if (sk->socket && test_bit(SOCK_INTER_MOSIX, &sk->socket->flags))
+		mosix_notify_receive(sk->socket);
+#endif /* CONFIG_MOSIX */
 	read_unlock(&sk->callback_lock);
 }
 
diff -Naur --exclude=CVS --exclude=configs linux/net/ipv4/af_inet.c linux-openmosix/net/ipv4/af_inet.c
--- linux/net/ipv4/af_inet.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/net/ipv4/af_inet.c	2004-02-05 10:51:33.000000000 +0100
@@ -117,6 +117,10 @@
 #include <linux/wireless.h>		/* Note : will define WIRELESS_EXT */
 #endif	/* CONFIG_NET_RADIO || CONFIG_NET_PCMCIA_RADIO */
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 struct linux_mib net_statistics[NR_CPUS*2];
 
 #ifdef INET_REFCNT_DEBUG
@@ -556,6 +560,10 @@
 
 	if (sk->num==0 && inet_autobind(sk) != 0)
 		return -EAGAIN;
+#ifdef CONFIG_MOSIX
+	if(reserved_mosix_address(uaddr))
+		return(-EACCES);
+#endif /* CONFIG_MOSIX */
 	return sk->prot->connect(sk, (struct sockaddr *)uaddr, addr_len);
 }
 
@@ -620,6 +628,11 @@
 		if (sk->state != TCP_CLOSE) 
 			goto out;
 
+#ifdef CONFIG_MOSIX
+		err = -EACCES;
+		if(reserved_mosix_address(uaddr))
+			goto out;
+#endif /* CONFIG_MOSIX */
 		err = sk->prot->connect(sk, uaddr, addr_len);
 		if (err < 0)
 			goto out;
diff -Naur --exclude=CVS --exclude=configs linux/net/ipv4/ip_sockglue.c linux-openmosix/net/ipv4/ip_sockglue.c
--- linux/net/ipv4/ip_sockglue.c	2003-08-25 13:44:44.000000000 +0200
+++ linux-openmosix/net/ipv4/ip_sockglue.c	2004-05-19 00:34:54.000000000 +0200
@@ -622,6 +622,17 @@
 				kfree(msf);
 				break;
 			}
+			/* numsrc >= (1G-4) overflow in 32 bits */
+			if (msf->imsf_numsrc >= 0x3ffffffcU) {
+				kfree(msf);
+				err = -ENOBUFS;
+				break;
+			}
+			if (IP_MSFILTER_SIZE(msf->imsf_numsrc) > optlen) {
+				kfree(msf);
+				err = -EINVAL;
+				break;
+			}
 			err = ip_mc_msfilter(sk, msf, 0);
 			kfree(msf);
 			break;
@@ -760,7 +771,12 @@
 			if (copy_from_user(gsf, optval, optlen)) {
 				goto mc_msf_out;
 			}
-			if (GROUP_FILTER_SIZE(gsf->gf_numsrc) < optlen) {
+			/* numsrc >= (4G-140)/128 overflow in 32 bits */
+			if (gsf->gf_numsrc >= 0x1ffffffU) {
+				err = -ENOBUFS;
+				goto mc_msf_out;
+			}
+			if (GROUP_FILTER_SIZE(gsf->gf_numsrc) > optlen) {
 				err = EINVAL;
 				goto mc_msf_out;
 			}
diff -Naur --exclude=CVS --exclude=configs linux/net/ipv4/tcp_input.c linux-openmosix/net/ipv4/tcp_input.c
--- linux/net/ipv4/tcp_input.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/net/ipv4/tcp_input.c	2004-02-05 10:51:33.000000000 +0100
@@ -2112,6 +2112,9 @@
 	return 0;
 }
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
 
 /* Look for tcp options. Normally only called on SYN and SYNACK packets.
  * But, this can also be called on packets in the established flow when
@@ -3177,7 +3180,13 @@
 	struct tcp_opt *tp = &(sk->tp_pinfo.af_tcp);
 	u32 ptr = ntohs(th->urg_ptr);
 
+#ifdef CONFIG_MOSIX
+	/* MOSIX sockets always use BSD style regardless of sysctl_tcp_stdurg */
+	if (ptr && (!sysctl_tcp_stdurg ||
+		(sk->socket && test_bit(SOCK_INTER_MOSIX, &sk->socket->flags))))
+#else
 	if (ptr && !sysctl_tcp_stdurg)
+#endif /* CONFIG_MOSIX */
 		ptr--;
 	ptr += ntohl(th->seq);
 
@@ -3204,6 +3213,17 @@
 
 	/* Tell the world about our new urgent pointer. */
 	if (sk->proc != 0) {
+#ifdef CONFIG_MOSIX
+		if (!sk->socket)
+#ifdef CONFIG_MOSIX_DEBUG
+			printk("tcp_check_urg: funny, no socket, sk=0x%x",
+									(int)sk)
+#endif /* CONFIG_MOSIX_DEBUG */
+				;
+		else if (test_bit(SOCK_INTER_MOSIX, &sk->socket->flags))
+			/*mosix_notify_urgent(sk->socket)*/ ;
+		else
+#endif /* CONFIG_MOSIX */
 		if (sk->proc > 0)
 			kill_proc(sk->proc, SIGURG, 1);
 		else
@@ -3265,6 +3285,15 @@
 			tp->urg_data = TCP_URG_VALID | tmp;
 			if (!sk->dead)
 				sk->data_ready(sk,0);
+#ifdef CONFIG_MOSIX
+			if (sk->socket &&
+				test_bit(SOCK_INTER_MOSIX, &sk->socket->flags))
+			{
+				if(tmp != 0xdb)
+					printk("tcp_urg: not 0xdb (%x)\n", tmp);
+				mosix_notify_urgent(sk->socket);
+			}
+#endif /* CONFIG_MOSIX */
 		}
 	}
 }
diff -Naur --exclude=CVS --exclude=configs linux/net/ipv6/ipv6_sockglue.c linux-openmosix/net/ipv6/ipv6_sockglue.c
--- linux/net/ipv6/ipv6_sockglue.c	2003-08-25 13:44:44.000000000 +0200
+++ linux-openmosix/net/ipv6/ipv6_sockglue.c	2004-05-19 00:34:55.000000000 +0200
@@ -466,6 +466,17 @@
 			kfree(gsf);
 			break;
 		}
+		/* numsrc >= (4G-140)/128 overflow in 32 bits */
+		if (gsf->gf_numsrc >= 0x1ffffffU) {
+			kfree(gsf);
+			retv = -ENOBUFS;
+			break;
+		}
+		if (GROUP_FILTER_SIZE(gsf->gf_numsrc) > optlen) {
+			kfree(gsf);
+			retv = -EINVAL;
+			break;
+		}
 		retv = ip6_mc_msfilter(sk, gsf);
 		kfree(gsf);
 
diff -Naur --exclude=CVS --exclude=configs linux/net/sunrpc/sched.c linux-openmosix/net/sunrpc/sched.c
--- linux/net/sunrpc/sched.c	2003-06-13 16:51:39.000000000 +0200
+++ linux-openmosix/net/sunrpc/sched.c	2004-02-05 10:51:34.000000000 +0100
@@ -1112,6 +1112,9 @@
 	 * Usually rpciod will exit very quickly, so we
 	 * wait briefly before checking the process id.
 	 */
+#ifdef CONFIG_MOSIX
+	current->mosix.ignoreoldsigs = 1;
+#endif /* CONFIG_MOSIX */
 	current->sigpending = 0;
 	yield();
 	/*
diff -Naur --exclude=CVS --exclude=configs linux/net/sunrpc/svc.c linux-openmosix/net/sunrpc/svc.c
--- linux/net/sunrpc/svc.c	2003-06-13 16:51:39.000000000 +0200
+++ linux-openmosix/net/sunrpc/svc.c	2004-02-05 10:51:34.000000000 +0100
@@ -198,6 +198,9 @@
 		progp->pg_name, proto == IPPROTO_UDP? "udp" : "tcp", port);
 
 	if (!port)
+#ifdef CONFIG_MOSIX
+		current->mosix.ignoreoldsigs = 1,
+#endif /* CONFIG_MOSIX */
 		current->sigpending = 0;
 
 	for (i = 0; i < progp->pg_nvers; i++) {
diff -Naur --exclude=CVS --exclude=configs linux/openMosix_MAINTAINERS linux-openmosix/openMosix_MAINTAINERS
--- linux/openMosix_MAINTAINERS	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/openMosix_MAINTAINERS	2004-03-11 18:02:27.000000000 +0100
@@ -0,0 +1,12 @@
+Current maintainers with commit bit are (not by any significant ordering):
+
+Matthias Rechenburg (kernel, user-space)	matt@qlusters.com
+Vincent Hanquez (kernel)			tab@tuxfamily.org
+Moshe Bar (kernel, user-space)			moshe@qlusters.com
+Bruce Knox (PR and webmaster)			bknox@uaex.edu
+Ettore Simone (kernel)				esimone@suse.it
+Jason Ferrara(kernel)				jason@xxx.com
+Aaron Peterson(CVS, sysadmin, userland)		aaronp@qlusters.com
+
+
+
